Index: code/trunk/src/orxonox/core/ObjectList.h
===================================================================
--- code/trunk/src/orxonox/core/ObjectList.h	(revision 265)
+++ code/trunk/src/orxonox/core/ObjectList.h	(revision 790)
@@ -1,12 +1,50 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file ObjectList.h
+    @brief Definition and implementation of the ObjectList class.
+
+    The ObjectList is a double-linked list, used by Identifiers to store all objects of a given class.
+    Newly created objects are added through the RegisterObject-macro in its constructor.
+    Use Iterator<class> to iterate through all objects of the class.
+*/
+
 #ifndef _ObjectList_H__
 #define _ObjectList_H__
 
+#include "CorePrereqs.h"
+#include "Iterator.h"
+
 namespace orxonox
 {
-    class OrxonoxClass;
-
     // ###############################
     // ###    ObjectListElement    ###
     // ###############################
+    //! The list-element of the ObjectList
     template <class T>
     class ObjectListElement
@@ -14,11 +52,14 @@
         public:
             ObjectListElement(T* object);
-            ~ObjectListElement();
-
-            T* object_;
-            ObjectListElement* next_;
-            ObjectListElement* prev_;
+
+            T* object_;                     //!< The object
+            ObjectListElement* next_;       //!< The next element in the list
+            ObjectListElement* prev_;       //!< The previous element in the list
     };
 
+    /**
+        @brief Constructor: Creates the list-element with an object.
+        @param object The object to store
+    */
     template <class T>
     ObjectListElement<T>::ObjectListElement(T* object)
@@ -29,40 +70,45 @@
     }
 
-    template <class T>
-    ObjectListElement<T>::~ObjectListElement()
-    {
-    }
-
 
     // ###############################
     // ###       ObjectList        ###
     // ###############################
-    template <class T>
-    class Iterator;
-
+    //! The ObjectList contains all objects of a given class.
+    /**
+        The ObjectList is used by Identifiers to store all objects of a given class.
+        Use Iterator<class> to iterate through all objects in the list.
+    */
     template <class T>
     class ObjectList
     {
         public:
+            static ObjectList<T>* getList();
+
+            ObjectListElement<T>* add(T* object);
+//            void remove(OrxonoxClass* object, bool bIterateForwards = true);
+
+            /** @returns the first element in the list */
+            inline static Iterator<T> start()
+                { return Iterator<T>(getList()->first_); }
+
+            /** @returns the first element in the list */
+            inline static Iterator<T> begin()
+                { return Iterator<T>(getList()->first_); }
+
+            /** @returns the last element in the list */
+            inline static Iterator<T> end()
+                { return Iterator<T>(getList()->last_); }
+
+            ObjectListElement<T>* first_;       //!< The first element in the list
+            ObjectListElement<T>* last_;        //!< The last element in the list
+
+        private:
             ObjectList();
             ~ObjectList();
-            ObjectListElement<T>* add(T* object);
-            void remove(OrxonoxClass* object, bool bIterateForwards = true);
-
-            inline static Iterator<T> start()
-                { return Iterator<T>(pointer_s->first_); }
-            inline static Iterator<T> end()
-                { return Iterator<T>(pointer_s->last_); }
-
-            ObjectListElement<T>* first_;
-            ObjectListElement<T>* last_;
-
-        private:
-            static ObjectList<T>* pointer_s;
     };
 
-    template <class T>
-    ObjectList<T>* ObjectList<T>::pointer_s = 0;
-
+    /**
+        @brief Constructor: Sets default values.
+    */
     template <class T>
     ObjectList<T>::ObjectList()
@@ -70,8 +116,9 @@
         this->first_ = 0;
         this->last_ = 0;
-
-        this->pointer_s = this;
-    }
-
+    }
+
+    /**
+        @brief Destructor: Deletes all list-elements, but NOT THE OBJECTS.
+    */
     template <class T>
     ObjectList<T>::~ObjectList()
@@ -86,4 +133,19 @@
     }
 
+    /**
+        @returns a pointer to the only existing instance for the given class T.
+    */
+    template <class T>
+    ObjectList<T>* ObjectList<T>::getList()
+    {
+        static ObjectList<T> theOnlyObjectListObjectForClassT = ObjectList<T>();
+        return &theOnlyObjectListObjectForClassT;
+    }
+
+    /**
+        @brief Adds a new object to the end of the list.
+        @param object The object to add
+        @return The pointer to the new ObjectListElement, needed by the MetaObjectList of the added object
+    */
     template <class T>
     ObjectListElement<T>* ObjectList<T>::add(T* object)
@@ -91,9 +153,11 @@
         if (!this->last_)
         {
+            // If the list is empty
             this->last_ = new ObjectListElement<T>(object);
-            this->first_ = this->last_;
+            this->first_ = this->last_; // There's only one object in the list now
         }
         else
         {
+            // If the list isn't empty
             ObjectListElement<T>* temp = this->last_;
             this->last_ = new ObjectListElement<T>(object);
@@ -105,4 +169,11 @@
     }
 
+
+//    /**
+//        @brief Removes an object from the list.
+//        @param object The object to remove
+//        @param bIterateForwards If true: Start searching the object at the beginning of the list
+//    */
+    /*
     template <class T>
     void ObjectList<T>::remove(OrxonoxClass* object, bool bIterateForwards)
@@ -111,4 +182,5 @@
             return;
 
+        // If there's only one object in the list, we have to set first_ and last_ to zero
         if (this->first_ == this->last_)
         {
@@ -123,6 +195,10 @@
         }
 
+        // Now we are sure we have more than one element in the list
         if (bIterateForwards)
         {
+            // Start at the beginning of the list
+
+            // Check if it's the first object
             if (this->first_->object_ == object)
             {
@@ -135,4 +211,5 @@
             }
 
+            // Iterate through the whole list
             ObjectListElement<T>* temp = this->first_;
             while (temp->next_)
@@ -146,5 +223,5 @@
                         temp2->prev_ = temp;
                     else
-                        this->last_ = temp;
+                        this->last_ = temp; // If there is no next_, we deleted the last element and have to update the last_ pointer.
 
                     return;
@@ -156,4 +233,7 @@
         else
         {
+            // Start at the end of the list
+
+            // Check if it's the last object
             if (this->last_->object_ == object)
             {
@@ -166,4 +246,5 @@
             }
 
+            // Iterate through the whole list
             ObjectListElement<T>* temp = this->last_;
             while (temp->prev_)
@@ -177,5 +258,5 @@
                         temp2->next_ = temp;
                     else
-                        this->first_ = temp;
+                        this->first_ = temp; // If there is no prev_, we deleted the first element and have to update the first_ pointer.
 
                     return;
@@ -186,5 +267,6 @@
         }
     }
+    */
 }
 
-#endif
+#endif /* _ObjectList_H__ */
Index: code/trunk/src/orxonox/core/OrxonoxClass.cc
===================================================================
--- code/trunk/src/orxonox/core/OrxonoxClass.cc	(revision 265)
+++ code/trunk/src/orxonox/core/OrxonoxClass.cc	(revision 790)
@@ -1,20 +1,56 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file OrxonoxClass.cc
+    @brief Implementation of the OrxonoxClass Class.
+*/
+
 #include "OrxonoxClass.h"
 
 namespace orxonox
 {
+    /** @brief Constructor: Sets the default values. */
     OrxonoxClass::OrxonoxClass()
     {
+        this->setConfigValues();
+
         this->identifier_ = 0;
         this->parents_ = 0;
 
-        this->metaList_ = new MetaObjectList;
+        this->bActive_ = true;
+        this->bVisible_ = true;
     }
 
+    /** @brief Destructor: Deletes, if existing, the list of the parents. */
     OrxonoxClass::~OrxonoxClass()
     {
+        // parents_ exists only if isCreatingHierarchy() of the associated Identifier returned true while creating the class
         if (this->parents_)
             delete this->parents_;
-
-        delete this->metaList_;
     }
 }
Index: code/trunk/src/orxonox/core/OrxonoxClass.h
===================================================================
--- code/trunk/src/orxonox/core/OrxonoxClass.h	(revision 265)
+++ code/trunk/src/orxonox/core/OrxonoxClass.h	(revision 790)
@@ -1,29 +1,164 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file OrxonoxClass.h
+    @brief Definition of the OrxonoxClass Class.
+
+    All objects and interfaces of the game-logic (not the engine) are derived from OrxonoxClass.
+    It stores the Identifier and the MetaObjectList and has all needed functions to create and use the class-hierarchy.
+*/
+
 #ifndef _OrxonoxClass_H__
 #define _OrxonoxClass_H__
 
-#include "Identifier.h"
-#include "IdentifierList.h"
-#include "ObjectList.h"
+#include <string>
+
+#include "CorePrereqs.h"
 #include "MetaObjectList.h"
+#include "Iterator.h"
 
 namespace orxonox
 {
-    class OrxonoxClass
+    //! The class all objects and interfaces of the game-logic (not the engine) are derived from.
+    /**
+        The BaseObject and Interaces are derived with 'virtual public OrxonoxClass' from OrxonoxClass.
+        OrxonoxClass is needed to create the class-hierarchy at startup and to store the Identifier and the MetaObjectList.
+    */
+    class _CoreExport OrxonoxClass
     {
         public:
             OrxonoxClass();
             virtual ~OrxonoxClass();
+
+            /** @brief Function to collect the SetConfigValue-macro calls. */
+            void setConfigValues() {};
+
+            /** @returns the Identifier of the object */
             inline Identifier* getIdentifier() const { return this->identifier_; }
+
+            /** @brief Sets the Identifier of the object. Used by the RegisterObject-macro. */
             inline void setIdentifier(Identifier* identifier) { this->identifier_ = identifier; }
+
+            /** @returns the list of all parents of the object */
             inline IdentifierList* getParents() const { return this->parents_; }
+
+            /** @brief Sets the Parents of the object. Used by the RegisterObject-macro. */
             inline void setParents(IdentifierList* parents) { this->parents_ = parents; }
-            inline MetaObjectList* getMetaList() { return this->metaList_; }
+
+            /** @returns the MetaObjectList of the object, containing a link to all ObjectLists and ObjectListElements the object is registered in. */
+            inline MetaObjectList& getMetaList() { return this->metaList_; }
+
+
+            /** @returns true if the objects class is of the given type or a derivative. */
+            inline bool isA(const Identifier* identifier)
+                { return this->getIdentifier()->isA(identifier); }
+            /** @returns true if the objects class is exactly of the given type. */
+            inline bool isDirectlyA(const Identifier* identifier)
+                { return this->getIdentifier()->isDirectlyA(identifier); }
+            /** @returns true if the objects class is a child of the given type. */
+            inline bool isChildOf(const Identifier* identifier)
+                { return this->getIdentifier()->isChildOf(identifier); }
+            /** @returns true if the objects class is a parent of the given type. */
+            inline bool isParentOf(const Identifier* identifier)
+                { return this->getIdentifier()->isParentOf(identifier); }
+
+
+            /** @returns true if the objects class is of the given type or a derivative. */
+            inline bool isA(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isA(identifier->getIdentifier()); }
+            /** @returns true if the objects class is exactly of the given type. */
+            inline bool isDirectlyA(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isDirectlyA(identifier->getIdentifier()); }
+            /** @returns true if the objects class is a child of the given type. */
+            inline bool isChildOf(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isChildOf(identifier->getIdentifier()); }
+            /** @returns true if the objects class is a parent of the given type. */
+            inline bool isParentOf(const SubclassIdentifier<class B>* identifier)
+                { return this->getIdentifier()->isParentOf(identifier->getIdentifier()); }
+
+
+            /** @returns true if the objects class is of the given type or a derivative. */
+            inline bool isA(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isA(identifier.getIdentifier()); }
+            /** @returns true if the objects class is exactly of the given type. */
+            inline bool isDirectlyA(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isDirectlyA(identifier.getIdentifier()); }
+            /** @returns true if the objects class is a child of the given type. */
+            inline bool isChildOf(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isChildOf(identifier.getIdentifier()); }
+            /** @returns true if the objects class is a parent of the given type. */
+            inline bool isParentOf(const SubclassIdentifier<class B> identifier)
+                { return this->getIdentifier()->isParentOf(identifier.getIdentifier()); }
+
+
+            /** @returns true if the objects class is of the given type or a derivative. */
+            inline bool isA(const OrxonoxClass* object)
+                { return this->getIdentifier()->isA(object->getIdentifier()); }
+            /** @returns true if the objects class is exactly of the given type. */
+            inline bool isDirectlyA(const OrxonoxClass* object)
+                { return this->getIdentifier()->isDirectlyA(object->getIdentifier()); }
+            /** @returns true if the objects class is a child of the given type. */
+            inline bool isChildOf(const OrxonoxClass* object)
+                { return this->getIdentifier()->isChildOf(object->getIdentifier()); }
+            /** @returns true if the objects class is a parent of the given type. */
+            inline bool isParentOf(const OrxonoxClass* object)
+                { return this->getIdentifier()->isParentOf(object->getIdentifier()); }
+
+
+            /** @brief Sets the name of the object. @param name The name */
+            inline virtual void setName(const std::string& name) { this->name_ = name; }
+
+            /** @returns the name of the object. */
+            inline const std::string& getName() const { return this->name_; }
+
+            /** @brief Sets the state of the objects activity. @param bActive True = active */
+            inline virtual void setActive(bool bActive) { this->bActive_ = bActive; }
+
+            /** @returns the state of the objects activity. */
+            inline const bool isActive() const { return this->bActive_; }
+
+            /** @brief Sets the state of the objects visibility. @param bVisible True = visible */
+            inline virtual void setVisible(bool bVisible) { this->bVisible_ = bVisible; }
+
+            /** @returns the state of the objects visibility. */
+            inline const bool isVisible() const { return this->bVisible_; }
 
         private:
-            Identifier* identifier_;
-            IdentifierList* parents_;
-            MetaObjectList* metaList_;
+            Identifier* identifier_;        //!< The Identifier of the object
+            IdentifierList* parents_;       //!< List of all parents of the object
+            MetaObjectList metaList_;       //!< MetaObjectList, containing all ObjectLists and ObjectListElements the object is registered in
+
+            std::string name_;              //!< The name of the object
+            bool bActive_;                  //!< True = the object is active
+            bool bVisible_;                 //!< True = the object is visible
     };
+    template class _CoreExport orxonox::ClassIdentifier<OrxonoxClass>;
+    template class _CoreExport orxonox::ObjectList<OrxonoxClass>;
 }
 
-#endif
+#endif /* _OrxonoxClass_H__ */
Index: code/trunk/src/orxonox/core/OutputHandler.cc
===================================================================
--- code/trunk/src/orxonox/core/OutputHandler.cc	(revision 790)
+++ code/trunk/src/orxonox/core/OutputHandler.cc	(revision 790)
@@ -0,0 +1,148 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "DebugLevel.h"
+#include "OutputHandler.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Opens the logfile and writes the first line.
+        @param logfilename The name of the logfile
+    */
+    OutputHandler::OutputHandler(const std::string& logfilename)
+    {
+        this->logfilename_ = logfilename;
+        this->logfile_.open(this->logfilename_.c_str(), std::fstream::out);
+        this->logfile_ << "Started log" << std::endl;
+        this->logfile_.flush();
+    }
+
+    /**
+        @brief Destructor: Writes the last line to the logfile and closes it.
+    */
+    OutputHandler::~OutputHandler()
+    {
+        this->logfile_ << "Closed log" << std::endl;
+        this->logfile_.close();
+    }
+
+    /**
+        @returns a reference to the only existing instance of the OutputHandler class.
+    */
+    OutputHandler& OutputHandler::getOutStream()
+    {
+        static OutputHandler orxout("orxonox.log");
+        return orxout;
+    }
+
+    /**
+        @brief Returns the soft debug level for a given output device.
+        @param device The output device
+        @return The debug level
+    */
+    int OutputHandler::getSoftDebugLevel(OutputHandler::OutputDevice device)
+    {
+        return DebugLevel::getSoftDebugLevel(device);
+    }
+
+    /**
+        @brief Overloaded << operator, redirects the output to the console and the logfile.
+        @param sb The streambuffer that should be shown in the console
+        @return A reference to the OutputHandler itself
+    */
+    OutputHandler& OutputHandler::operator<<(std::streambuf* sb)
+    {
+        if (getSoftDebugLevel(OutputHandler::LD_Console) >= this->outputLevel_)
+            std::cout << sb;
+
+        if (getSoftDebugLevel(OutputHandler::LD_Logfile) >= this->outputLevel_)
+        {
+            this->logfile_ << sb;
+            this->logfile_.flush();
+        }
+
+        return *this;
+    }
+
+    /**
+        @brief Overloaded << operator, redirects the output to the console and the logfile.
+        @param manipulator A function, manipulating the outstream.
+        @return A reference to the OutputHandler itself
+    */
+    OutputHandler& OutputHandler::operator<<(std::ostream& (*manipulator)(std::ostream&))
+    {
+        if (getSoftDebugLevel(OutputHandler::LD_Console) >= this->outputLevel_)
+            manipulator(std::cout);
+
+        if (getSoftDebugLevel(OutputHandler::LD_Logfile) >= this->outputLevel_)
+        {
+            manipulator(this->logfile_);
+            this->logfile_.flush();
+        }
+
+        return *this;
+    }
+
+    /**
+        @brief Overloaded << operator, redirects the output to the console and the logfile.
+        @param manipulator A function, manipulating the outstream.
+        @return A reference to the OutputHandler itself
+    */
+    OutputHandler& OutputHandler::operator<<(std::ios& (*manipulator)(std::ios&))
+    {
+        if (getSoftDebugLevel(OutputHandler::LD_Console) >= this->outputLevel_)
+            manipulator(std::cout);
+
+        if (getSoftDebugLevel(OutputHandler::LD_Logfile) >= this->outputLevel_)
+        {
+            manipulator(this->logfile_);
+            this->logfile_.flush();
+        }
+
+        return *this;
+    }
+
+    /**
+        @brief Overloaded << operator, redirects the output to the console and the logfile.
+        @param manipulator A function, manipulating the outstream.
+        @return A reference to the OutputHandler itself
+    */
+    OutputHandler& OutputHandler::operator<<(std::ios_base& (*manipulator)(std::ios_base&))
+    {
+        if (getSoftDebugLevel(OutputHandler::LD_Console) >= this->outputLevel_)
+            manipulator(std::cout);
+
+        if (getSoftDebugLevel(OutputHandler::LD_Logfile) >= this->outputLevel_)
+        {
+            manipulator(this->logfile_);
+            this->logfile_.flush();
+        }
+
+        return *this;
+    }
+}
